<?php
namespace Teknisa\SUP\Modules\Cadastros\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class FornecedorNaoAtendeController extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $dataSourceName = "fornecedornaoatende";
	protected $connection;

	 public function __construct($crudService, ParameterBag $parameterBag, $connection) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->con = $connection;
    }
    /*
	public function delete(DTO\Request $request, DTO\Response $response) {
		try {
		    var_dump($request);
			die();
            foreach($request->getDataSet()->getRows() as $row){
                    $row["CDREGIAO"] = null;
                }
			$rows = $this->crudService->getRowsToSave($request, $this->dataSourceName);
			
			$this->crudService->save($this->dataSourceName, $rows);
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}*/
	
	public function save(DTO\Request $request, DTO\Response $response){
		$query = "SELECT count(*) FROM FILIAL WHERE (FILIAL.CDREGIAO = :P_CDREGIAO) AND ((EXISTS (SELECT CDFORNECED FROM REFORFIL WHERE REFORFIL.CDFORNECED = :P_CDFORNECED AND REFORFIL.CDFILIAL = FILIAL.CDFILIAL AND REFORFIL.CDPERIENTR IS NOT NULL)) OR (NOT EXISTS (SELECT CDFORNECED FROM REFORFIL WHERE REFORFIL.CDFORNECED = :P_CDFORNECED AND REFORFIL.CDFILIAL = FILIAL.CDFILIAL)))";
		$stmt = $this->con->prepare($query);
		 $stmt->execute(array(
		 	"P_CDREGIAO" => $request->getDataSet()->getRows()[0]['CDREGIAO'],
		 	"P_CDFORNECED" => $request->getDataSet()->getRows()[0]['CDFORNECED']
		 ));
		 
		 $result = $stmt->fetchAll();

		  if($result[0]['COUNT(*)'] > 0 ){
			$response->setError(new Error("Operação bloqueada. Fornecedor atende a filiais da região escolhida.", 500));
		  }
		  else {
		  	try {
				$query = 'insert into REFOREG
							(CDREGIAO, CDFORNECED)
							values
							(:CDREGIAO, :CDFORNECED)';
				$stmt = $this->con->prepare($query);
				$stmt->execute(array(
					"CDREGIAO" => $request->getDataSet()->getRows()[0]['CDREGIAO'],
					"CDFORNECED" => $request->getDataSet()->getRows()[0]['CDFORNECED']
				));
	
			} catch (\Exception $e) {
				if(strpos($e->getMessage(),'ORA-00001') !== -1)
					$response->setError(new Error('esse fornecedor já está cadastrado na tabela ', 500));
				else
					$response->setError(new Error($e->getMessage(), 500));
			}
		  }
	}
}