<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\AnaliseCotacoes\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Sup00600HistoricoComparativoCotacoesController extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $qr2Strategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;
    protected $birtStrategy;

    public function __construct($reportService, $entityManager, $qr2Strategy,$dataSourceManager,$newCode, $environment, $connection,$birtStrategy) {

        $this->entityManager       = $entityManager;
        $this->qr2Strategy         = $qr2Strategy;
        $this->reportService       = $reportService;
        $this->dataSourceManager   = $dataSourceManager;
        $this->newCode             = $newCode;
        $this->environment         = $environment;
        $this->connection          = $connection;
        $this->birtStrategy       = $birtStrategy;
        
    }
    

    protected $reportMapping = array ();
     
     public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){   
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        $this->stNomeRel = $this->getReportName($row);
        
        if($this->stNomeRel=='SUP00600' || $this->stNomeRel=='SUP00601'|| $this->stNomeRel=='SUP00602'){
            //cria L_cdregiao
        if( $row['REGIAO']=='T'){
            $row['REGIAO']=$this->retornaRegiao();
        }
        $row['REGIAO']=$this->criarListaValores($row['REGIAO']);
            //cria lista de filial
            if( $row['FILIAL']=='T'){
                $row['FILIAL']=$this->retornaFiliais();
            }
            $row['FILIAL']=$this->criarListaValores($row['FILIAL']);
            //cria lista de fornecedor
            if($row['FORNECEDOR']=='T'){
                $row['FORNECEDOR']=$this->retornaFornecedores($row);
            }
            $row['FORNECEDOR']=$this->criarListaValores($row['FORNECEDOR']);
            //cria lista de fornecedor
            if($row['CDFORNECED1']=='T'){
                $row['CDFORNECED1']=$this->retornaFornecedores($row);
            }
            $row['CDFORNECED1']=$this->criarListaValores($row['CDFORNECED1']);
             //cria lista de CDFILIALCENTCMP1
            if( $row['CDFILIALCENTCMP1']=='T'){
                $row['CDFILIALCENTCMP1']=$this->retornaFiliais();        }
            $row['CDFILIALCENTCMP1']=$this->criarListaValores($row['CDFILIALCENTCMP1']);
        }
        //Valores de Filial
        $row['CDFILIAL1'] = $row['CDFILIAL'];
        $row['CDFILIAL2'] = $row['CDFILIAL'];
        $row['CDFILIAL3'] = $row['CDFILIAL'];
        //Valor do pramentro de NRORG
        $row['P_NRORG'] = $this->environment->getNrorgTrab();
        if($this->stNomeRel=='SUP00600' || $this->stNomeRel=='SUP00601'|| $this->stNomeRel=='SUP00602'){  
            $this->reportMapping[$this->stNomeRel] =
                array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                array (
                    "REGIAO"            => "L_CDREGIAO",
                    "FILIAL"            => "L_CDFILIAL",
                    "CDFILIALCENTCMP1"  => "L_CDFILCENTCMP",
                    "CDFILIAL"          => "P_CDFILIAL",
                    "FORNECEDOR"        => "L_CDFORNECED",
                    "CDFORNECED1"       => "L_CDFORNECED1",
                    "CDARVPRODINI"         => "P_CDINI",
                    "CDARVPRODFIM"         => "P_CDFIN",
                    "CDARVPRODINI1"        => "P_CDARVPRODINI",
                    "CDARVPRODFIM1"        => "P_CDARVPRODFIN",
                    "DTINI"             => "P_DTINI", 
                    "DTFIN"             => "P_DTFIN",
                    "DTINI1"            => "P_DTINICIAL",
                    "DTFIN1"            => "P_DTFINAL",
                    "P_NRORG"           => "P_NRORG"
                ),
            );
        }
        if($this->stNomeRel=='SUP00603'){ 
              $this->reportMapping[$this->stNomeRel] =
                array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                array (
                    "REGIAO"            => "P_CDREGIAO",
                    "FORNECEDOR"        => "P_CDFORNECED",
                    "CDARVPRODINI"         => "P_CDARVPRODINI",
                    "CDARVPRODFIM"         => "P_CDARVPRODFIN",
                    "DTINI"             => "P_DATAINI", 
                    "DTFIN"             => "P_DATAFIN",
                    "P_NRORG"           => "P_NRORG"
                ),
            );
        } 
    }
         //insere lista no banco
    public function insertLista($nrlista, $cdlista) {
        $params = array(
            "NRLISTA" => $nrlista,
            "CDLISTA" => $cdlista
        );
        
        $sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
    //cria lista de valores recebendo string como parametro
    public function criarListaValores($valores){
       
            $this->entityManager->beginTransaction();
            $lista = explode('_',$valores);
            $nrlista = $this->newCode->getCodeByTableName('LISTA', $this->environment->getNrorgTrab(), 1, 10, false);
            try{
                foreach($lista as $key){
                    $this->insertLista($nrlista, $key);
                }
                $this->entityManager->commit();
                return $nrlista;
            } catch(\Exception $e){
                $this->entityManager->rollback();
                throw $e;
            }
        
    }
    private function insereLista($nrlista, $filiserv) {
		$rows = array();
		foreach($filiserv as $filialservico){
			array_push($rows,
				array(
					"NRLISTA" 	=> $nrlista,
					"CDLISTA" 	=> $filialservico,
					"__is_new"  => true
				)
			);
		}
		$dataSet = new DataSet(null, $rows);
		$request = new DTO\Request\DataSet($dataSet, '', '', '');
		$rowsToSave = $this->crudService->getRowsToSave($request, 'lista');
		$this->crudService->save('lista', $rowsToSave);
	}
	//retorna array de regiões
     public function retornaRegiao(){
         $sql = "SELECT CDREGIAO FROM REGIAO";

        try {
            $regiao = $this->entityManager->getConnection()->fetchAll($sql);
            return implode('_', array_column($regiao, 'CDREGIAO'));
        } catch (\Exception $e) {
            throw $e;
        }
     }
   //retorna array de unidades
    public function retornaFiliais(){
           $sql = "SELECT CDFILIAL FROM FILIAL";

        try {
            $filial = $this->entityManager->getConnection()->fetchAll($sql);
            return implode('_', array_column($filial, 'CDFILIAL'));
        } catch (\Exception $e) {
            throw $e;
        }
    }
    //retorna array de fornecedores
    public function retornaFornecedores(){
         $sql = "SELECT CDFORNECED FROM FORNECEDOR";

        try {
            $fornecedor = $this->entityManager->getConnection()->fetchAll($sql);
            return implode('_', array_column($fornecedor, 'CDFORNECED'));
        } catch (\Exception $e) {
            throw $e;
        }
     }
}



   
  
        


