<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\AnaliseCotacoes\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;


class Sup01500EvolucaoInflacaoController extends \Zeedhi\Framework\Controller\Report {

    
    protected $entityManager;
    protected $birtStrategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    
   
    

    public function __construct($reportService, $entityManager, $birtStrategy, $newCode, $environment, $connection) {
        $this->reportService  = $reportService;
        $this->entityManager  = $entityManager;
        $this->birtStrategy    = $birtStrategy;
        $this->newCode        = $newCode;
        $this->environment    = $environment;
        $this->connection     = $connection;
    }
    
    protected $reportMapping = array (
        
        'SUP01500' =>
            array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "CDREG"                => "P_CDREGIAO",
                "P_TCDREGIAO"          => "P_TCDREGIAO",
                "P_DATAINI"            => "P_DATAINI",
                "P_DATAFIN"            => "P_DATAFIN",
                "P_CDPRODINI"          => "P_CDPRODINI",
                "P_CDPRODFIN"          => "P_CDPRODFIN",
                "P_CDGRUPPROD"         => "P_CDGRUPPROD",
                "CDSUB"                => "P_CDSUBGRPROD",
                "P_TCDSUBGRPROD"       => "P_TCDSUBGRPROD",
                "P_PERIODOMES"         => "P_PERIODOMES",
                "P_RANKING"            => "P_RANKING",
                "P_NRORG"              => "P_NRORG"
            )
        )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row['P_CDREGIAO']      = $row['CDREGIAO'];
        $row['P_TCDREGIAO']     = $row['TCDREGIAO'];
        $row['P_DATAINI']       = $row['DTINI'];
        $row['P_DATAFIN']       = $row['DTFIN'];
        $row['P_CDPRODINI']     = $row['CDPRODINI'];
        $row['P_CDPRODFIN']     = $row['CDPRODFIN'];
        $row['P_CDGRUPPROD']    = $row['CDGRUPPROD'];
        $row['P_CDSUBGRPROD']   = $row['CDSUBGRPROD'];
        $row['P_TCDSUBGRPROD']  = $row['TCDSUBGRPROD'];
        $row['P_PERIODOMES']    = $row['PERIODOMES'];
        $row['P_RANKING']       = $row['RANKING'];
        $row['P_NRORG']         = $this->environment->getNrOrg();
        $row['__report_name']   = 'SUP01500';
        $this->birtStrategy->setReportFormat('PDF');
      
    }

}